




Number.prototype.format=function(len,len2){
	var pair=String(this).split(/\./);
	if(pair[0].length<len){
		pair[0]=('00000000000000000'+pair[0]).slice(-len);
	}
	if(len2){
		return(pair[0]+'.'+((''+(pair[1]||0)+'0000000000000000').slice(0,len2)));
	}else{
		return(pair[0]);
	}
}







String.prototype.encodeHTML=function(){
	return(this
		.replace(/&/g,'&amp;')
		.replace(/>/g,'&gt;')
		.replace(/</g,'&lt;')
		.replace(/"/g,'&quot;')
		.replace(/\r?\n/g,'<br>')
	);
};

String.prototype.decodeHTML=function(){
	return(this.replace(/<br>/ig,"\n").replace(/<.*?>/ig,"").decodeHTMLSpecialChars());
}



String.prototype.decodeHTMLSpecialChars=function(){
	var dict={'amp':'&','gt':'>','lt':'<','quot':'"','nbsp':' '};
	return(this.replace(/&([a-z]+);/ig,function($0,$1){
		return(dict[$1]||$0);
	}));
}



function run(cmd){
	(new ActiveXObject('WScript.Shell')).Run(cmd);
}



function load(n,code){
	var s;
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>1)?(code?code:'_autodetect'):'utf-8';
		Open();
		loadFromFile(n);
		s=ReadText();
		Close();
	}
	return(s);
}
function save(str,n,code){
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>2)?code:'utf-8';
		Open();
		WriteText(str);
		saveToFile(n,2);
		Close();
	}
}




function fromJSON(str){
	var __FROM_JSON_TEMP__;
	eval((''+str).replace(/^\s*/,'__FROM_JSON_TEMP__=')+';');
	return(__FROM_JSON_TEMP__);
}
function toJSON(obj){
	switch(typeof(obj)){
		case('object'):{
			if(obj==null){
				return('null');
			}else if(obj instanceof Array){
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(obj[i]));
				}
				return('[\n'+res.join(',\n')+'\n]');
			}else{
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(i)+':'+toJSON(obj[i]));
				}
				return('{\n'+res.join(',\n')+'\n}');
			}
		}case('boolean'):case('number'):{
			return(obj.toString());
		}case('function'):{
			return(obj.toString().replace(/\{\n +\[native code\]\n}$/,"{}"));
		}case('string'):{
			return('"'+obj.replace(/\\/g,"\\\\").replace(/[\n\r"]/g,function($1){switch($1){
					case("\n"):{return("\\n");}
					case("\r"):{return("\\r");}
					case('"'):{return('\\"');}
				}})+'"');
		}
	}
}
function loadJSON(name){
	return(fromJSON(load(name)));
}
function saveJSON(obj,file){
	save(toJSON(obj),file);
}







function curl(options,workdir){
	//CURLɂHTTPANZXs
	var curl=basedir+"bin\\curl.exe";
	var cookie=basedir+"bin\\cookie.txt";
	var cmd='"'+curl+'" -k -b "'+cookie+'" -c "'+cookie+'" -A "Monazilla/1.00" -L '+options;
	var ws=new ActiveXObject("WScript.Shell");
	if(workdir){
		ws.CurrentDirectory=workdir;
	}
	ws.Run(cmd,0,true);
}
function curl_clear(){
	file_delete(basedir+"bin\\cookie.txt");
	file_delete(basedir+"bin\\tmp_html.txt");
}


function get(url,no_charconv){
	//url擾ĕԂ
	var file=basedir+"bin\\tmp_html.txt";
	curl('-o "'+file+'" '+url);
	
	if(!no_charconv){
		var html=load(file,"_autodetect");
		if(html.match(/content="[^"]*charset=(.*?)"/i)){
			html=load(file,RegExp.$1);
		}
	}else{
		var html=load(file,"ascii");
	}
	return(html);
}


function post(url,d,no_load,is_multipart){
	//urlpostsAԂ
	var file=basedir+"bin\\tmp_html.txt";
	var data;
	if(typeof(d)=='string'){
		data=' -d "'+d+'"';
	}else if(is_multipart){
		var data='';
		for(var i in d){
			data+=' -F "'+i+'='+d[i]+'"';
		}
	}else{
		var ary=[];
		for(var i in d){
			ary.push(encodeURIComponent(i)+'='+encodeURIComponent(d[i]));
		}
		data=' -d "'+ary.join('&')+'"';
	}
	curl('-o "'+file+'" '+data+' '+url);
	if(no_load){
		return(file);
	}else{
		var html=load(file,"");
		return(html);
	}
}










FileSystemObject= new ActiveXObject("Scripting.FileSystemObject");

absPath=function(p){
	return(FileSystemObject.GetAbsolutePathName(p));
};

buildPath=function(p1,p2){
	return(absPath(FileSystemObject.BuildPath(p1,p2)));
};

File=function(file){
	if(typeof(file)=='string'){
		this.__axo__=null;
		this.path=file;
	}else{
		this.__axo__=file;
		this.path=file.Path;
	}
	this.name=this.path.replace(/^.*\\/,'');
	this.basename=this.name.replace(/\.\w+$/,'');
	this.ext=this.path.replace(/^.*\./,'.');
	
};

File.prototype={
	getActiveXObject:function(){
		if(!this.__axo__){
			if(FileSystemObject.FileExists(this.path)){
				this.__axo__=FileSystemObject.GetFile(this.path);
			}
		}
		return(this.__axo__);
	},
	getParent:function(func){
		return(new Directory(this.getActiveXObject().ParentFolder));
	},

	sizeOf:function(){
		var o=this.getActiveXObject();
		return(o?o.Size:0);
	},
	lastModified:function(){
		var o=this.getActiveXObject();
		return(new Date(o?o.DateLastModified:0));
	},

	exists:function(){
		return(FileSystemObject.FileExists(this.path));
	},
	
	remove:function(){
		var o=this.getActiveXObject();
		if(o){
			o.Delete();
		}
	},


	toString:function(){
		return(this.path);
	}
};
File.escapeName=function(name){
	return(name.replace(/[^ ()+,-.;=@^_`{}0-9A-Za-zN}L~---σ-քF@-v]\efghdc񁌁T-]@-I-ˁ́́݁΁ށ-ځa-臓߁⁼ۇ܇@-S---@-VX-l-J-U@-E-S-ei`cakjdlfn_mbgh~-rso-qut-II-`-]/g,function($0){return(encodeURIComponent($0));}));
};
File.exists=function(p){
	return(FileSystemObject.FileExists(p));
};

function mkdir(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(path.match(/^(.*)\\([^\\]*)\\?$/)){
				if(!FolderExists(RegExp.$1)){
					mkdir(RegExp.$1);
				}
				CreateFolder(path);
			}
		}
	}catch(e){
	}
}
function file_delete(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(FileExists(path)){
				GetFile(path).Delete();
			}
		}
	}catch(e){
	}
}






function echo(msg){
	WScript.echo(msg);
}






function BBSMenu(){
	this.bbsByURL={};
	this.bbsByName={};
	this.bbsByTitle={};
	this.bbs=[];
	
	
	var html;
	
	if(((new Date).getTime()-(new File(basedir+'bin\\bbsmenu.html')).lastModified().getTime())<24*60*60*1000){
		html=load(basedir+'bin\\bbsmenu.html');
	}else{
		html=get(Config.BBSMenu||'http://menu.2ch.net/bbsmenu.html');
		save(html,basedir+'bin\\bbsmenu.html');
	}
	
	var lines=html.split(/[\n\r]+/);
	var category='';
	var _this=this;
	for(var i=0,l=lines.length;i<l;i++){
		lines[i].replace(/<B>(.*?)<\/B><BR>/i,function($0,$1){
			category=$1;
		});
		lines[i].replace(/<A HREF=(http:\/\/(.*?)\/([^\/]*)\/)>(.*?)<\/A>/i,function($0,url,server,name,title){
			var b={server:server,name:name,category:category,title:title};
			_this.bbsByURL[url]=b;
			_this.bbsByName[b.name]=b;
			_this.bbsByTitle[b.title]=b;
			_this.bbs.push(b);
		});
	}
	bbsmenu=this;
}

var bbsmenu;
function getBBSMenu(){
	if(!bbsmenu){
		bbsmenu=new BBSMenu();
	}
	return(bbsmenu);
}


BBSMenu.prototype.getBBS=function(name){
	var obj=this.bbsByURL[name]||this.bbsByName[name]||this.bbsByTitle[name];
	if(!obj && name.match(/^http:\/\//)){
		var t=this;
		name.replace(/^http:\/\/(.*?)\/([^\/]+)\/[^\/]*$/,function($0,$1,$2){
			obj=t.bbsByURL[name]={server:$1,name:$2};
		});
	}
	if(obj){
		if(!obj.bbs){
			obj.bbs=new BBS(obj.server,obj.name,obj.category,obj.title);
		}
		return(obj.bbs);
	}
};

BBSMenu.prototype.findThreads=function(bbsname,keyword){
	var res=[];
	var bbs=this.getBBS(bbsname);
	if(bbs){
		var t=bbs.getThreads();
		for(var i=0,l=t.length;i<l;i++){
			if(t[i].match(keyword)){
				res.push(t[i]);
			}
		}
	}
	return(res);
};












function BBS(server,name,category,title){
	var url='http://'+server+'/'+name+'/';
	this.server=server;
	this.name=name;
	this.url=url;
	this.category=category||'';
	this.title=title||'';
	var obj={
		Category:this.category||'O',
		BBSName:this.title||'^CgȂ',
		BBSURLName:this.name,
		BBSServer:this.server,
		BBSURL:this.url
	};
	this.dirPath=''+Config.LogDir+(''+Config.LogPathFormat).replace(/%(\w+)%/ig,function($0,$1){return(File.escapeName(obj[$1]));})+'\\';
	try{
		this.memo=loadJSON(basedir+"bin\\"+File.escapeName(this.url)+".json");
	}catch(e){
		this.memo={};
	}
}
BBS.prototype.saveMemoData=function(){
	saveJSON(this.memo,basedir+"bin\\"+File.escapeName(this.url)+".json");
};

BBS.prototype.match=function(kw){
	if(kw instanceof Array){
		for(var i=0,l=kw.length;i<l;i++){
			if(this.match(kw[i])){
				return(true);
			}
		}
		return(false);
	}else{
		return(this.name==kw||this.title==kw||this.url==kw);
	}
};


BBS.prototype.getThreads=function(reload){
	if(reload||!this.threads){
		var a=get(this.url+'subject.txt').split(/[\n\r]+/);
		var r=[];
		var b=this;
		var tc=0,ts=0;
		for(var i=0,l=a.length;i<l;i++){
			a[i].replace(/^(\d+)\.dat<>(.*?) ?\((\d+)\)$/,function($0,$1,$2,$3){
				if(1*$1>930000000){
					var t=new Thread(b,$1,$2,$3);
					tc+=t.count;
					ts+=t.speed;
					r.push(t);
				}
			});
		}
		this.threadCount=r.length;
		this.totalCount=tc;
		this.avgCount=tc/r.length;
		this.totalSpeed=ts;
		this.avgSpeed=ts/r.length;
		this.threads=r;
	}
	return(this.threads);
};




BBS.prototype.getSettings=function(){
	if(!this.settings){
		var a=get(this.url+"SETTING.TXT").split(/[\n\r]+/);
		var s={};
		for(var i=0,l=a.length;i<l;i++){
			a[i].replace(/^(.*?)=(.*)$/,function($0,$1,$2){
				s[$1]=$2;
			});
		}
		this.settings=s;
	}
	return(this.settings);
};

BBS.prototype.getMaxMessageLines=function(){
	return((this.getSettings['BBS_LINE_NUMBER']||12)*2);
};

BBS.prototype.getMaxMessageBytes=function(){
	return(this.getSettings['BBS_MESSAGE_COUNT']||2048);
}


BBS.prototype.getWriteInterval=function(){
	if(!this.writeInterval){
		var res=120000;
		get(this.url).replace(/.*\+Samba24=(\d+)<br>/i,function($0,$1){
			res=$1*1000;
		});
		this.writeInterval=res;
	}
	return(this.writeInterval);
};






BBS.prototype.createVirtualThread=function(title,name,mail,msg){
	var id=this.memo.nextVirtualThread*1||0;
	mkdir(this.dirPath);
	save(name.encodeHTML()+'<>'+mail.encodeHTML()+'<>'+(new Date())+'<>'+msg.encodeHTML()+'<>'+title.encodeHTML()+"\n",this.dirPath+id+".dat",'Shift_JIS');
	this.memo.nextVirtualThread=id+1;
	return(id);
};



BBS.prototype.writeVirtualThread=function(id,name,mail,msg){
	save(load(this.dirPath+id+".dat",'Shift_JIS')+String(name).encodeHTML()+'<>'+String(mail).encodeHTML()+'<>'+(new Date())+'<>'+String(msg).encodeHTML()+'<>\n',this.dirPath+id+".dat",'Shift_JIS');
};










function Thread(bbs,id,title,count){
	this.url='http://'+bbs.server+'/test/read.cgi/'+bbs.name+'/'+id+'/';
	this.bbs=bbs;
	this.id=id;
	this.title=title||"";
	this.count=count||1;
	
	this.datURL=bbs.url+"dat/"+this.id+".dat";
	this.datPath=bbs.dirPath+this.id+".dat";
	
	var md=bbs.memo;
	if(!md[this.id]){
		md[this.id]={};
	}
	this.memo=md[this.id];
	
	if(!this.memo.readLines){
		if(this.isRead()){
			this.memo.readLines=load(this.datPath,"Shift_JIS").split(/[\n\r]+/).length;
		}else{
			this.memo.readLines=0;
		}
	}
	this.readLines=this.memo.readLines;
	
	if(!this.memo.countLog){
		this.newThread=true;
		this.memo.countLog=[{time:id*1000,count:1}];
	}
	var log=this.memo.countLog,log2=[];
	var now=(new Date()).getTime();
	if((log.length>0) && (log[0].count==count)){
		this.elapsed=now-log[0].time;
	}else{
		this.elapsed=0;
		log2.push({time:now,count:count});
	}
	for(var i=0,l=log.length;i<l;i++){
		log2.push(log[i]);
		if(((log[i].count+10)<count)&&((log[i].time+12*60*60*1000)<now)){
			break;
		}
	}
	var last=log2[log2.length-1];
	this.memo.countLog=log2;
	this.speed=24*60*60*1000*(count-last.count)/(now-last.time);
	this.avgSpeed=24*60*60*1000*count/(now-id*1000);
	this.acceleration=this.speed/this.avgSpeed;
}

Thread.fromURL=function(url){
	var res;
	url.replace(/^http:\/\/(.*?)\/test\/read\.cgi\/(.*?)\/(\d+)\/[^\/]*$/,function($0,server,name,id){
		var bm=getBBSMenu();
		var bbs=bm.getBBS(name);
		if(!bbs){
			bbs=new BBS(server,name);
			bm.bbsByURL['http://'+server+'/'+name+'/']={server:server,name:name,bbs:bbs};
		}
		res=new Thread(bbs,id);
	});
	return(res);
};

Thread.prototype.saveMemoData=function(){
	this.bbs.saveMemoData();
};


Thread.prototype.calculateTrendLevel=function(ex){
	with(this){
		return(eval(ex));
	}
};

Thread.prototype.match=function(kw){
	if(kw instanceof Array){
		for(var i=0,l=kw.length;i<l;i++){
			if(this.match(kw[i])){
				return(true);
			}
		}
		return(false);
	}else{
		return(this.title.indexOf(kw)!=-1 || this.url==kw);
	}
};

Thread.prototype.isRead=function(){
	return(File.exists(this.datPath));
}
Thread.prototype.getReadBytes=function(){
	if(this.isRead()){
		return((new File(this.datPath)).sizeOf());
	}else{
		return(0);
	}
};


Thread.prototype.getRes=function(){
	curl(this.datURL+' --output "'+this.datPath+'" --create-dirs --continue-at -');
	
	var a=load(this.datPath,'Shift_JIS').split(/[\n\r]+/);
	var r=[];
	var t=this;
	for(var i=0,l=a.length;i<l;i++){
		a[i].replace(/^(.*?)<>(.*?)<>(.*?)<>(.*?)<>(.*)$/,function($0,$1,$2,$3,$4,$5){
			if($5){
				t.title=$5;
			}
			r.push(new Res(t,i+1, $1,$2,$3,$4));
		});
	}
	if(i>this.count){
		this.count=i;
	}
	this.readLines=this.memo.readLines=this.count;
	return(r);
}



Thread.prototype.write=function(name,mail,msg){
	var postdata='time='+Math.floor(((new Date()).getTime()/1000) -60)+'&bbs='+this.bbs.name+'&key='+this.id+'&submit=%8F%91%82%AB%8D%9E%82%DE&FROM='+encodeURIComponent(name)+'&mail='+encodeURIComponent(mail);
	
	var tempname=basedir+"bin\\writemsg.txt";
	save(msg,tempname,"Shift_JIS");
	var url='--data-urlencode "MESSAGE@'+tempname+'" -e '+this.url+' http://'+this.bbs.server+'/test/bbs.cgi?guid=ON';
	
	var resHTML=post(url,postdata);
	if(resHTML.indexOf('݂܂')!=-1){
		return resHTML.indexOf('http-equiv=refresh')!=-1;
	}
	resHTML.replace(/<input[^>]*hidden[^>]*>/ig,function($0){
		var n,v;
		$0.replace(/name="?([^ >"]*)/i,function($0,$1){
			n=$1;
		}).replace(/value="?([^ >"]*)/i,function($0,$1){
			v=$1;
		});
		if(postdata.indexOf(n+'=')==-1){
			postdata+='&'+n+'='+v;
		}
	});
	resHTML=post(url,postdata);
	return(resHTML.indexOf('݂܂')!=-1);
};










function Res(thread,num, name,mail,date,message){
	this.thread=thread;
	this.bbs=thread.bbs;
	this.number=num;
	this.name=name;
	this.mail=mail;
	this.date=date;
	this.message=message;
}

Res.prototype.getURLs=function(){
};

Res.prototype.getAnchors=function(){
	var list={};
	this.message.replace(/(?:&gt;||)(\d+)/g,function($0,$1){
		list[$1]=true;
	}).replace(/(?:&gt;||)(\d+)-(\d+)/g,function($0,$1,$2){
		for(var i=$1;i<=$2;i++){
			list[i]=true;
		}
	});
	var res=[];
	for(var i in list){
		res.push(i);
	}
	return(res.sort());
};

Res.prototype.getPlainTextMessage=function(){
	return(this.message.decodeHTML());
};
Res.prototype.getPlainText=function(){
	return((''+this.number)+': '+(this.name.decodeHTML())+' '+(this.date.decodeHTML())+"\n"+(this.getPlainTextMessage()));
};

Res.prototype.trimLines=function(num){
	var a=this.getPlainText().split(/[\n\r]+/);
	if(a.length>num){
		return(a.slice(0,num).join("\n")+"("+(a.length-num)+"sȗ)");
	}else{
		return(a.join("\n"));
	}
};

Res.prototype.match=function(kw){
	if(kw instanceof Array){
		for(var i=0,l=kw.length;i<l;i++){
			if(this.match(kw[i])){
				return(true);
			}
		}
		return(false);
	}else{
		return(
			(this.message.indexOf(kw)!=-1)
			||(this.name.indexOf(kw)!=-1)
			||(this.mail.indexOf(kw)!=-1)
			||(this.date.indexOf(kw)!=-1)
		);
	}
};


Res.prototype.parseSurrogateRequest=function(){
	var res={};
	var a=this.message.split(/<br>/i);
	var body;
	for(var i=0,l=a.length;i<l;i++){
		if(body){
			body.push(a[i]);
		}else{
			a[i].replace(/^y.*?URL.*?z\s*(.*)$/,function($0,$1){
				res.thread=$1;
			});
			a[i].replace(/^y.*?O.*?z\s*(.*)$/,function($0,$1){
				res.name=$1;
			});
			a[i].replace(/^y.*?[.*?z\s*(.*)$/,function($0,$1){
				res.mail=$1;
			});
			a[i].replace(/^y.*?{.*?z(.*)$/,function($0,$1){
				body=[];
			});
		}
		
	}
	if(body && res.thread){
		res.message=body.join("\n").decodeHTML();
		return(res);
	}
}





Config=loadJSON(basedir+'config.js');

